<!doctype html>
<html lang="en">

<head>
    <title>province</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="">
        <h1 class="text-center my-3">PROVINCE</h1>
        <div class="jumbotron">
            <div class="row">

                <div class="col-sm-4">
                    <h2>Tỉnh Thành add
                    </h2>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""> <b>Tỉnh thành</b></label>
                        </div>
                        <div class="col-sm-8">
                            <input type="text" name="" id="inp-province-name" class=" form-control">

                            </select>
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""><b>Mã</b></label>
                        </div>
                        <div class="col-sm-8">
                            <input type="text" name="" id="inp-province-code" class=" form-control">
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">

                        </div>
                        <div class="col-sm-8">
                            <button id="btn-add-province" class="btn btn-success mr-2 px-4 py-2">Add</button>
                            <button class="btn btn-light px-3 py-2 mr-2">Cancel</button>
                            <button id="btn-ok-up" class="btn btn-primary px-3 py-2">Ok Up</button>

                        </div>
                    </div>



                </div>
                <div class="col-sm-4">
                    <h2>Quận Huyện add
                    </h2>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""> <b>Tên </b></label>
                        </div>
                        <div class="col-sm-8">
                            <input type="text" id="inp-district-name" class="form-control">
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""><b>Quận-Huyện</b></label>
                        </div>
                        <div class="col-sm-8">
                            <input type="text" id="inp-district-prefix" class="form-control">
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for="">
                                <div class=" row ml-1">
                                    <b>Tên TP </b>
                                    &nbsp;
                                    <p class="text-danger">*</p>
                                </div>
                            </label>


                        </div>
                        <div class="col-sm-8">
                            <select name="" id="" class="select-province form-control"></select>
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">

                        </div>
                        <div class="col-sm-8">
                            <button id="btn-add-district" class="btn btn-success mr-2 px-4 py-2">Add</button>
                            <button class="btn btn-light px-4 py-2">Cancel</button>
                        </div>
                    </div>



                </div>
                <div class="col-sm-4">
                    <h2>Phường xã add
                    </h2>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for="">
                                <div class=" row ml-1">
                                    <b>Tên</b>
                                    &nbsp;
                                    <p class="text-danger">*</p>
                                </div>
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input type="text" id="inp-ward-name" class="form-control">
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""><b>Phường xã</b></label>
                        </div>
                        <div class="col-sm-8">
                            <input type="text" id="inp-ward-prefix" class="form-control">
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""><b>Tỉnh thành</b></label>
                        </div>
                        <div class="col-sm-8">
                            <select name="" id="" class="select-province form-control"></select>
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">
                            <label for=""><b>Quận huyện</b></label>
                        </div>
                        <div class="col-sm-8">
                            <select name="" id="" class="select-district form-control"></select>
                        </div>
                    </div>
                    <div class="row mt-3">
                        <div class="col-sm-4">

                        </div>
                        <div class="col-sm-8">
                            <button id="btn-add-ward" class="btn btn-success mr-2 px-4 py-2">Add</button>
                            <button class="btn btn-light px-4 py-2">Cancel</button>
                        </div>
                    </div>



                </div>
            </div>
            <div class="row">
                <div class="col-sm-4">
                    <label for="">Province</label>
                    <select name="" id="select-province" class="select-province form-control"></select>
                    <button id="btn-delete-province" class="btn btn-danger mt-3 px-4 py-2">Xóa</button>
                    <button id="btn-update-province" class="btn btn-warning mt-3 px-4 py-2">Sửa</button>
                </div>
                <div class="col-sm-4">
                    <label for="">district</label>
                    <select name="" id="select-district-province" class="form-control"></select>
                    <button id="btn-delete-district" class="btn btn-danger mt-3 px-4 py-2">Xóa</button>
                    <button id="btn-update-district" class="btn btn-warning mt-3 px-4 py-2">Sửa</button>
                </div>
                <div class="col-sm-4">
                    <label for="">ward</label>
                    <select name="" id="select-ward-district" class="form-control"></select>
                    <button id="btn-delete-ward" class="btn btn-danger mt-3 px-4 py-2">Xóa</button>
                    <button id="btn-update-ward" class="btn btn-warning mt-3 px-4 py-2">Sửa</button>
                </div>
            </div>
        </div>

    </div>



</body>
<script>
    // ****************Regon1***************//
    const gBASE_URL_PROVINCE = "http://localhost:8080/province/"
    const gBASE_URL_DISTRICT = "http://localhost:8080/district/"
    const gBASE_URL_WARD = "http://localhost:8080/ward/"
    var gDataProvince = "";
    // ****************Regon2***************//
    $(document).ready(function () {
        onLoadSelectProvince();
        onLoadSelectDistrict();
        $("#btn-add-province").on("click", function () {
            onBtnAdd();
        })
        $("#btn-add-district").on("click", function () {
            onBtnAddDistrict();
        })
        $("#btn-add-ward").on("click", function () {
            onBtnAddWard();
        })
        $(".select-province").on("change", function () {
            var vId = $("#select-province").val();

            onLoadDistrictProvince(vId);
        })
        $("#select-district-province").on("change", function () {
            var vId = $("#select-district-province").val();

            onLoadWardDistrict(vId);
        })
        $("#btn-delete-ward").on("click", function () {
            var result = confirm("you really delete ward");
            var vId = $("#select-ward-district").val();
            if (result == true) {
                alert("Yes");
                onBtnDeleteWard(vId);

            }
            else {
                alert("No");

            }
        })
        $("#btn-delete-district").on("click", function () {
            var result = confirm("you really delete district");
            var vId = $("#select-district-province").val();
            if (result == true) {
                alert("Yes");
                onBtnDeleteDistrict(vId);

            }
            else {
                alert("No");

            }
        })
        $("#btn-delete-province").on("click", function () {
            var result = confirm("you really delete province");
            var vId = $("#select-province").val();
            if (result == true) {
                alert("Yes");
                onBtnDeleteProvince(vId);

            }
            else {
                alert("No");

            }
        })
        $("#btn-update-province").on("click", function () {

            $("#inp-province-name").val(gDataProvince.name);
            $("#inp-province-code").val(gDataProvince.code);

        })
        $("#btn-ok-up").on("click", function () {
            var vId = $("#select-province").val();
            onBtnUpdateProvince(vId);
        })

    })
    // ****************Regon3***************//
    function onLoadSelectProvince() {
        $.ajax({
            url: gBASE_URL_PROVINCE + "all",
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                console.log(paramRes.length)
                handleLoadProvince(paramRes);
                // handleLoadCodeProvince(paramRes);
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }
        })
    }
    function onLoadSelectDistrict() {
        $.ajax({
            url: gBASE_URL_DISTRICT + "all",
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                console.log(paramRes.length)
                handleLoadDistrict(paramRes);

            },
            error: function (paramErr) {
                alert(paramErr.status);
            }
        })
    }
    function onBtnAddProvince() {
        var vObjProvince = {
            name: "",
            code: "",
        }
        thuThapThongTin(vObjProvince);
        $.ajax({
            url: gBASE_URL_PROVINCE + "create",
            type: "POST",
            data: JSON.stringify(vObjProvince),
            contentType: "application/json;charset=UTF-8",
            success: function (paramRes) {
                alert("Add province success");
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }

        })
    }
    function onBtnAddDistrict(paramId) {
        var vObjDistrict = {
            name: "",
            prefix: "",
            province_id: "",
        }
        thuThapThongTinDistrict(vObjDistrict);
        $.ajax({
            url: gBASE_URL_DISTRICT + "create/" + vObjDistrict.province_id,
            type: "POST",
            data: JSON.stringify(vObjDistrict),
            contentType: "application/json;charset=UTF-8",
            success: function (paramRes) {
                alert("Add district success");
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }

        })
    }
    function onBtnAddWard(paramId) {
        var vObjWard = {
            name: "",
            prefix: "",
            district_id: "",
        }
        thuThapThongTinWard(vObjWard);
        $.ajax({
            url: gBASE_URL_WARD + "create/" + vObjWard.district_id,
            type: "POST",
            data: JSON.stringify(vObjWard),
            contentType: "application/json;charset=UTF-8",
            success: function (paramRes) {
                alert("Add ward success");
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }

        })
    }
    function onBtnDeleteWard(id) {
        $.ajax({
            url: gBASE_URL_WARD + "delete/" + id,
            type: "DELETE",
            success: function (paramRes) {
                alert("delete ward success");
                location.reload();
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }
        })
    }
    function onBtnDeleteDistrict(id) {
        $.ajax({
            url: gBASE_URL_DISTRICT + "delete/" + id,
            type: "DELETE",
            success: function (paramRes) {
                alert("delete district success");
                location.reload();
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }
        })
    }
    function onBtnDeleteProvince(id) {
        $.ajax({
            url: gBASE_URL_PROVINCE + "delete/" + id,
            type: "DELETE",
            success: function (paramRes) {
                alert("delete province success");
                location.reload();
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }
        })
    }
    function onBtnUpdateProvince(id) {
        var vObjProvince = {
            name: $("#inp-province-name").val(),
            code: $("#inp-province-code").val()
        }


        $.ajax({
            url: gBASE_URL_PROVINCE + "update/" + id,
            type: "PUT",
            data: JSON.stringify(vObjProvince),
            contentType: "application/json;charset=UTF-8",
            success: function (paramRes) {
                alert("update province success");
                location.reload();
            },
            error: function (paramErr) {
                alert(paramErr.status);
            }
        })
    }


    function onLoadDistrictProvince(id) {
        $.ajax({
            url: gBASE_URL_PROVINCE + "details/" + id,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                gDataProvince = paramRes;
                $("#select-district-province").html("");
                handleLoadDistrictProvince(paramRes);
            }
        })
    }
    function onLoadWardDistrict(id) {
        $.ajax({
            url: gBASE_URL_DISTRICT + "details/" + id,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                $("#select-ward-district").html("");
                handleLoadWardDistrict(paramRes);
            }
        })
    }
    // ****************Regon4***************//
    function handleLoadProvince(paramRes) {

        for (var bI = 0; bI < paramRes.length; bI++) {

            $(".select-province").append($("<option/>", {
                text: paramRes[bI].name,
                value: paramRes[bI].id
            }))
        }
    }
    function handleLoadDistrict(paramRes) {
        for (var bI = 0; bI < paramRes.length; bI++) {

            $(".select-district").append($("<option/>", {
                text: paramRes[bI].name,
                value: paramRes[bI].id
            }))
        }
    }
    function handleLoadDistrictProvince(paramRes) {
        for (var bI = 0; bI < paramRes.districts.length; bI++) {

            $("#select-district-province").append($("<option/>", {
                text: paramRes.districts[bI].name,
                value: paramRes.districts[bI].id
            }))
        }
    }
    function handleLoadWardDistrict(paramRes) {
        for (var bI = 0; bI < paramRes.wards.length; bI++) {

            $("#select-ward-district").append($("<option/>", {
                text: paramRes.wards[bI].name,
                value: paramRes.wards[bI].id
            }))
        }
    }
    function thuThapThongTin(paramObj) {
        paramObj.name = $("#inp-province-name").val();
        paramObj.code = $("#inp-province-code").val();

    }
    function thuThapThongTinDistrict(paramObj) {
        paramObj.name = $("#inp-district-name").val();
        paramObj.prefix = $("#inp-district-prefix").val();
        paramObj.province_id = $(".select-province").val();

    }
    function thuThapThongTinWard(paramObj) {
        paramObj.name = $("#inp-ward-name").val();
        paramObj.prefix = $("#inp-ward-prefix").val();
        paramObj.district_id = $(".select-district").val();

    }

</script>

</html>